function ConfigurationGenerator

a =  [1, 10, 1/10]; % ratio between silent and fail-stop error rates
a =  [1.5, 2, 0.5]; % ratio between silent and fail-stop error rates
errorTypes = ['F '; 'S '; 'FS']; 
errorTypes = ['FS']; 
VCTypes = ['C '; 'VC'];
VCTypes = ['VC'];
% We only do VC_FS, VC_S, VC_F, C_FS, we ignore C_F, C_S

b = 1550;
d = 3;  % sensitivity parameter
s_cpu = [0.15, 0.4, 0.6, 0.8, 1];
k = length(s_cpu);
s_max = s_cpu(k);
s_min = s_cpu(1);
s_ref = s_cpu(ceil(k/2)); % 0.6

P_cpu = 60;
P_io = P_cpu;
s_io = s_cpu(length(s_cpu));

e_ref = 10^(-5);
e_f = e_ref * 10.^(d*abs(s_ref*ones(1,k) - s_cpu)/(s_max-s_min));

for t = 1:length(errorTypes)
    for c = 1:length(VCTypes)
        for i = 1:length(a)
            
            errorType = strtrim(errorTypes(t, :));
            VCType = strtrim(VCTypes(c, :));
            if strcmp(errorType, 'F') && strcmp(VCType, 'C')
                continue;
            end
            if strcmp(errorType, 'S') && strcmp(VCType, 'C')
                continue;
            end            
            e_s = a(i) * e_f; 
            
            filename = strcat(VCType, '_', errorType, '_eta=', num2str(a(i)), '.config');
            fid = fopen(filename, 'w');            
            if fid ~= -1
                    
                  fprintf(fid,'%s\n', VCType);
                  fprintf(fid,'%f\n', P_cpu);
                  fprintf(fid,'%f\n', P_io);       
                  fprintf(fid,'%f\n', s_io);
                  fprintf(fid,'%f\n', b);

                  fprintf(fid,'%d\n', k);

                  for j = 1:k
                      fprintf(fid,'%f\t', s_cpu(j));
                  end
                  fprintf(fid,'\n');

                  for j = 1:k
                      if strcmp(errorType, 'S')
                          fprintf(fid,'%f\t', 0);
                      else
                          fprintf(fid,'%f\t', e_f(j));
                      end
                  end
                  fprintf(fid,'\n');

                  for j = 1:k
                      if strcmp(errorType, 'F')
                          fprintf(fid,'%f\t', 0);
                      else
                          fprintf(fid,'%f\t', e_s(j));
                      end
                  end

                  fclose(fid);   
                  if strcmp(errorType, 'F') || strcmp(errorType, 'S')
                         break; 
                  end
            end
        end
    end
end