function ConfigurationGeneratorNew

etas =  [0, 0.1, 1, 10, 100]; % ratio between silent and fail-stop error rates
errorType = 'FS'; 
VCTypes = ['C '; 'VC'];
% We only do VC_FS, VC_S, VC_F, C_FS, we ignore C_F, C_S

comment = 'New_';

b = 1550;
d = 3;  % sensitivity parameter
s_cpu = [0.15, 0.4, 0.6, 0.8, 1];
k = length(s_cpu);
s_max = s_cpu(k);
s_min = s_cpu(1);
s_ref = s_cpu(ceil(k/2)); % 0.6

P_cpu = 60;
P_io = P_cpu;
s_io = s_cpu(length(s_cpu));

e_ref = 10^(-5);
e_total = e_ref * 10.^(d*abs(s_ref*ones(1,k) - s_cpu)/(s_max-s_min));

for c = 1:length(VCTypes)
    for i = 1:length(etas)

        errorType = strtrim(errorType);
        VCType = strtrim(VCTypes(c, :));
        eta = etas(i);

        if eta == 0
            e_f = e_total;
            e_s = zeros(1, k);
        elseif eta == 100
            e_f = zeros(1, k);
            e_s = e_total;
        else
            e_f = e_total/(eta+1);
            e_s = e_total*eta/(eta+1);
        end

        filename = strcat(comment, VCType, '_', errorType, '_eta=', num2str(eta), '.config');
        fid = fopen(filename, 'w');            
        if fid ~= -1

              fprintf(fid,'%s\n', VCType);
              fprintf(fid,'%f\n', P_cpu);
              fprintf(fid,'%f\n', P_io);       
              fprintf(fid,'%f\n', s_io);
              fprintf(fid,'%f\n', b);

              fprintf(fid,'%d\n', k);

              for j = 1:k
                  fprintf(fid,'%f\t', s_cpu(j));
              end
              fprintf(fid,'\n');

              for j = 1:k
                  if strcmp(errorType, 'S')
                      fprintf(fid,'%f\t', 0);
                  else
                      fprintf(fid,'%f\t', e_f(j));
                  end
              end
              fprintf(fid,'\n');

              for j = 1:k
                  if strcmp(errorType, 'F')
                      fprintf(fid,'%f\t', 0);
                  else
                      fprintf(fid,'%f\t', e_s(j));
                  end
              end

              fclose(fid);   
        end
    end
end

end