#ifndef MAIN_HPP
#define MAIN_HPP

#include <limits>

#define INF std::numeric_limits<double>::max();

struct speed
{
	int k;
	double s, lf, ls;
};

void reset(int n);

double W(int i, int j);

double TV(int i, int j, int lc, int kv, speed sp);

double TimeVfirst(int i, int j, int kv, speed sp1);

double TimeV(int i, int j, int kv, speed sp);

double TVCfirst(int i, int j, speed sp, int &nv);

double TVCsec(int i, int j, speed sp, int &nv);

double TVC(int i, int j, speed sp1, speed sp2, int &nv1, int &nv2);

double computeTime(int n, speed sp1, speed sp2, int &nckpt, int &nv1, int &nv2);

bool launch(const char *filename, int n, int ks, double *speed, double *lambdaF, double *lambdaS);

bool read_params(const char *filename, double *pcpu, double *pio, double *sio, double *alpha, int *ks, double **speed, double **lambdaF, double **lambdaS);

bool read_chain(const char *filename, int *n, double **w, double **v, double **c, double **r);

#endif