#ifndef OPTIME_HPP
#define OPTIME_HPP

#include <limits>

#define INF std::numeric_limits<double>::max();

void reset(int n);

double W(int i, int j);

double TV(int i, int j, int lc, int kv, double s, double lf, double ls, double &e);

float TC(int i, int j, float s, float lf, float ls);

double TimeV(int i, int j, int kv, double s, double lf, double ls, double &e);

double TimeVC(int j, int k, double s, double lf, double ls, int &nv, double &e);

float TimeC(int j, int k, float s, float lf, float ls);

double computeTime(int n, double s, double lf, double ls, int &nckpt, double &e);

bool launch(const char *filename, int n, int ks, double *speed, double *lambdaF, double *lambdaS);

bool read_params(const char *filename, double *sio, double *pcpu, double *pio, double *alpha, int *ks, double **speed, double **lambdaF, double **lambdaS);

bool read_chain(const char *filename, int *n, double **w, double **v, double **c, double **r);

#endif